/*
    QGL PrimitiveEditor
    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PRIMITIVEEDITOR_H
#define PRIMITIVEEDITOR_H

#include "qglview.h"

#include <QWidget>


namespace Ui {
class PrimitiveEditor;
}


class PrimitiveEditor: public QWidget {
	Q_OBJECT

public:
	enum PrimitiveType {
		Plane,
		Cube,
		Ellipsoid,
		Disc,
		Cone,
		Cylinder,
		Torus
	};
	Q_ENUMS(PrimitiveType)

	explicit PrimitiveEditor(QWidget * parent = nullptr);
	~PrimitiveEditor();

	void assignQGLView(QGLView * v);

	ObjectBase * createCurrent();

protected:
	Mesh * createMesh(QVariantList & params);
	void showEditors();

	Ui::PrimitiveEditor * ui;
	QGLView * view;
	QMap<PrimitiveType, QList<QWidget *>> editors;
	QList<QWidget *> all_editors;
	bool can_replace;

private slots:
	void selectionChanged();
	void replaceMesh();
	void on_buttonAdd_clicked();
	void on_comboPrimitives_currentIndexChanged(int index);
};


#endif // PRIMITIVEEDITOR_H
